# Code generated by `stubgen`. DO NOT EDIT.
import unittest
from .config_exception import ConfigException as ConfigException
from .dateutil import parse_rfc3339 as parse_rfc3339
from .kube_config import CommandTokenSource as CommandTokenSource, ConfigNode as ConfigNode, ENV_KUBECONFIG_PATH_SEPARATOR as ENV_KUBECONFIG_PATH_SEPARATOR, FileOrData as FileOrData, KubeConfigLoader as KubeConfigLoader, KubeConfigMerger as KubeConfigMerger, list_kube_config_contexts as list_kube_config_contexts, load_kube_config as load_kube_config, load_kube_config_from_dict as load_kube_config_from_dict, new_client_from_config as new_client_from_config
from kubernetes.client import Configuration as Configuration
from typing import Any

BEARER_TOKEN_FORMAT: str
EXPIRY_DATETIME_FORMAT: str
PAST_EXPIRY_TIMEDELTA: int
FUTURE_EXPIRY_TIMEDELTA: int
NON_EXISTING_FILE: str
TEST_FILE_KEY: str
TEST_DATA_KEY: str
TEST_FILENAME: str
TEST_DATA: str
TEST_DATA_BASE64: Any
TEST_ANOTHER_DATA: str
TEST_ANOTHER_DATA_BASE64: Any
TEST_HOST: str
TEST_USERNAME: str
TEST_PASSWORD: str
TEST_BASIC_TOKEN: str
DATETIME_EXPIRY_PAST: Any
DATETIME_EXPIRY_FUTURE: Any
TEST_TOKEN_EXPIRY_PAST: Any
TEST_SSL_HOST: str
TEST_CERTIFICATE_AUTH: str
TEST_CERTIFICATE_AUTH_BASE64: Any
TEST_CLIENT_KEY: str
TEST_CLIENT_KEY_BASE64: Any
TEST_CLIENT_CERT: str
TEST_CLIENT_CERT_BASE64: Any
TEST_OIDC_TOKEN: str
TEST_OIDC_INFO: str
TEST_OIDC_BASE: Any
TEST_OIDC_LOGIN: Any
TEST_OIDC_EXP: str
TEST_OIDC_EXP_BASE: Any
TEST_OIDC_EXPIRED_LOGIN: Any
TEST_OIDC_CONTAINS_RESERVED_CHARACTERS: Any
TEST_OIDC_INVALID_PADDING_LENGTH: Any
TEST_OIDC_CA: Any
TEST_AZURE_LOGIN = TEST_OIDC_LOGIN
TEST_AZURE_TOKEN: str
TEST_AZURE_TOKEN_FULL: Any

class BaseTestCase(unittest.TestCase):
    def setUp(self) -> None: ...
    def tearDown(self) -> None: ...
    def expect_exception(self, func, message_part, *args, **kwargs) -> None: ...

class TestFileOrData(BaseTestCase):
    @staticmethod
    def get_file_content(filename): ...
    def test_file_given_file(self) -> None: ...
    def test_file_given_non_existing_file(self) -> None: ...
    def test_file_given_data(self) -> None: ...
    def test_file_given_data_no_base64(self) -> None: ...
    def test_data_given_data(self) -> None: ...
    def test_data_given_file(self) -> None: ...
    def test_data_given_file_no_base64(self) -> None: ...
    def test_data_given_file_and_data(self) -> None: ...
    def test_file_given_file_and_data(self) -> None: ...
    def test_file_with_custom_dirname(self) -> None: ...
    def test_create_temp_file_with_content(self) -> None: ...
    def test_file_given_data_bytes(self) -> None: ...
    def test_file_given_data_bytes_no_base64(self) -> None: ...
    def test_file_given_no_object(self) -> None: ...
    def test_file_given_no_object_data(self) -> None: ...

class TestConfigNode(BaseTestCase):
    test_obj: Any
    node: Any
    def setUp(self) -> None: ...
    def test_normal_map_array_operations(self) -> None: ...
    def test_get_with_name(self) -> None: ...
    def test_key_does_not_exists(self): ...
    def test_get_with_name_on_invalid_object(self): ...
    def test_get_with_name_on_non_list_object(self): ...
    def test_get_with_name_on_name_does_not_exists(self): ...
    def test_get_with_name_on_duplicate_name(self): ...

class FakeConfig:
    FILE_KEYS: Any
    api_key: Any
    def __init__(self, token: Any | None = ..., **kwargs) -> None: ...
    def __eq__(self, other): ...

class TestKubeConfigLoader(BaseTestCase):
    TEST_KUBE_CONFIG: Any
    def test_no_user_context(self) -> None: ...
    def test_simple_token(self) -> None: ...
    def test_load_user_token(self) -> None: ...
    def test_gcp_no_refresh(self): ...
    def test_load_gcp_token_no_refresh(self): ...
    def test_load_gcp_token_with_refresh(self): ...
    def test_gcp_get_api_key_with_prefix(self) -> None: ...
    def test_oidc_no_refresh(self) -> None: ...
    def test_oidc_with_refresh(self, mock_ApiClient, mock_OAuth2Session) -> None: ...
    def test_oidc_with_refresh_nocert(self, mock_ApiClient, mock_OAuth2Session) -> None: ...
    def test_oidc_fails_if_contains_reserved_chars(self) -> None: ...
    def test_oidc_fails_if_invalid_padding_length(self) -> None: ...
    def test_azure_no_refresh(self) -> None: ...
    def test_azure_with_expired_num(self) -> None: ...
    def test_azure_with_expired_str(self) -> None: ...
    def test_azure_with_expired_str_error(self) -> None: ...
    def test_azure_with_expired_int_error(self) -> None: ...
    def test_user_pass(self) -> None: ...
    def test_load_user_pass_token(self) -> None: ...
    def test_ssl_no_cert_files(self) -> None: ...
    def test_ssl(self) -> None: ...
    def test_ssl_no_verification(self) -> None: ...
    def test_list_contexts(self) -> None: ...
    def test_current_context(self) -> None: ...
    def test_set_active_context(self) -> None: ...
    def test_ssl_with_relative_ssl_files(self) -> None: ...
    def test_load_kube_config_from_file_path(self) -> None: ...
    def test_load_kube_config_from_file_like_object(self) -> None: ...
    def test_load_kube_config_from_dict(self) -> None: ...
    def test_load_kube_config_from_dict_with_temp_file_path(self) -> None: ...
    def test_load_kube_config_from_empty_file_like_object(self) -> None: ...
    def test_load_kube_config_from_empty_file(self) -> None: ...
    def test_list_kube_config_contexts(self) -> None: ...
    def test_new_client_from_config(self) -> None: ...
    def test_no_users_section(self) -> None: ...
    def test_non_existing_user(self) -> None: ...
    def test_user_exec_auth(self, mock) -> None: ...
    def test_user_exec_auth_certificates(self, mock) -> None: ...
    def test_user_cmd_path(self) -> None: ...
    def test_user_cmd_path_empty(self): ...
    def test_user_cmd_path_with_scope(self): ...
    def test__get_kube_config_loader_for_yaml_file_no_persist(self) -> None: ...
    def test__get_kube_config_loader_for_yaml_file_persist(self) -> None: ...
    def test__get_kube_config_loader_file_no_persist(self) -> None: ...
    def test__get_kube_config_loader_file_persist(self) -> None: ...
    def test__get_kube_config_loader_dict_no_persist(self) -> None: ...

class TestKubernetesClientConfiguration(BaseTestCase):
    def test_get_api_key_with_prefix_exists(self) -> None: ...
    def test_get_api_key_with_prefix_returns_token(self) -> None: ...
    def test_auth_settings_calls_get_api_key_with_prefix(self): ...

class TestKubeConfigMerger(BaseTestCase):
    TEST_KUBE_CONFIG_PART1: Any
    TEST_KUBE_CONFIG_PART2: Any
    TEST_KUBE_CONFIG_PART3: Any
    TEST_KUBE_CONFIG_PART4: Any
    TEST_KUBE_CONFIG_PART5: Any
    TEST_KUBE_CONFIG_PART6: Any
    def test_list_kube_config_contexts(self) -> None: ...
    def test_new_client_from_config(self) -> None: ...
    def test_save_changes(self) -> None: ...
